
Redmine - Defect #6681

Mercurial, Bazaar and Darcs auto close issue text should be commit id instead of revision number

2010-10-15 14:45 - Toshi MARUYAMA

Status: Closed Start date: 2010-10-15

Priority: Normal Due date:  

Assignee:  % Done: 50%

Category: SCM Estimated time: 0.00 hour

Target version: 1.1.0   

Resolution: Fixed Affected version: 1.0.2

Description

Mercurial and Bazaar have revision numbers.

Mercurial revision numbers are far too brittle (#3724).

Same Bazaar problem is reported at http://www.redmine.org/boards/2/topics/17587?r=17591#message-17591 .

Redmine generates pseudo revision number for Darcs at source:tags/1.0.2/app/models/repository/darcs.rb#L73 .

If "closes #issue_number" is in commit log, Redmine adds "Applied in changeset rN" at issue journal.

Following two Mercurial repository are full synchronized.

And revision 1 and 2 are different for each other.

If we delete the repository from project setting and re-add another repository,

"rN" points other revision.

$ hg glog

o  changeset:   2:9d5b5b004199

|  tag:         tip

|  parent:      0:0885933ad4f6

|  user:        jsmith <jsmith@foo.bar>

|  date:        Fri Dec 14 10:24:01 2007 +0100

|  summary:     Added 2 files and modified one.

|

| @  changeset:   1:505aa36abc94

|/   branch:      branch00

|    user:        jsmith <jsmith@foo.bar>

|    date:        Fri Oct 15 20:09:50 2010 +0900

|    summary:     test.

|

o  changeset:   0:0885933ad4f6

   user:        jsmith <jsmith@foo.bar>

   date:        Fri Dec 14 10:22:52 2007 +0100

   summary:     Initial import.

 
$ hg glog

@  changeset:   2:505aa36abc94

|  branch:      branch00

|  tag:         tip

|  parent:      0:0885933ad4f6

|  user:        jsmith <jsmith@foo.bar>

|  date:        Fri Oct 15 20:09:50 2010 +0900

|  summary:     test.

|

| o  changeset:   1:9d5b5b004199

|/   user:        jsmith <jsmith@foo.bar>

|    date:        Fri Dec 14 10:24:01 2007 +0100

|    summary:     Added 2 files and modified one.

|

o  changeset:   0:0885933ad4f6

   user:        jsmith <jsmith@foo.bar>

   date:        Fri Dec 14 10:22:52 2007 +0100

   summary:     Initial import.

2025-05-17 1/2

https://www.redmine.org/issues/3724
http://www.redmine.org/boards/2/topics/17587?r=17591#message-17591
https://www.redmine.org/projects/redmine/repository/svn/entry/tags/1.0.2/app/models/repository/darcs.rb#L73


 I post a patch and a Mercurial image.

This patch master is http://bitbucket.org/yuja/redmine-mq-issue4455/src/d6bc15c54f5d/hg-use-scmid.patch/issue-auto-close.diff .

 

Related issues:

Related to Redmine - Defect #3724: Mercurial repositories display revision ID... Closed 2009-08-10

Related to Redmine - Defect #8030: Bazaar integration doesn't notice new comm... New 2011-03-31

Associated revisions

Revision 4490 - 2010-12-11 15:20 - Jean-Philippe Lang

Fixes Changeset#text_tag for numeric scmid (#6681).

Contributed by Toshi MARUYAMA.

Revision 4858 - 2011-02-16 16:43 - Toshi MARUYAMA

scm: in repository tree, use find_changeset_by_name instead of changesets.find_by_revision (#3724, #3421).

Mercurial revision numbers are far too brittle.

Please see #6681 description.

History

#1 - 2010-12-11 15:12 - Jean-Philippe Lang

- Status changed from New to Closed

- Target version set to 1.1.0

- Resolution set to Fixed

Latest patch found in #4155 committed in r4490.

Thanks.

Files

issue-auto-close.diff 1.59 KB 2010-10-15 Toshi MARUYAMA

auto-close-hg.png 55.3 KB 2010-10-15 Toshi MARUYAMA
